################################################################################
## Ansible Settings
################################################################################

ansible_python_interpreter: auto
swap_file_size_mb: "2048"
swap_swappiness: "10"
internal_cidr_16: "{{ (ansible_default_ipv4.address + '/16') | ipaddr('network/prefix') }}"

system_packages: [aptitude, curl, openssh-server, ca-certificates, glances, nano, tzdata, ack-grep, tree, python3-pip, nfs-common, postfix, jq, libpq-dev]
python_packages: [requests==2.26.0, google-auth==2.0.1, netaddr==0.8.0, openshift==0.12.1, PyYAML==5.4.1, docker==5.0.0, pexpect==4.8.0, psycopg2==2.9.1]

################################################################################
## Cloud Provider Settings
################################################################################

internal_ip_lookup: {gcp: ['networkInterfaces', 0, 'networkIP'], azure: ['private_ipv4_addresses', 0], aws: ['private_ip_address'], alicloud: ['private_ip_address'], tencentcloud: ['private_ip_address']}
external_ip_lookup: {gcp: ['networkInterfaces', 0, 'accessConfigs', 0, 'natIP'], azure: ['public_ipv4_addresses', 0], aws: ['public_ip_address'], alicloud: ['public_ip_address'], tencentcloud: ['public_ip_address'] }

## GCP
gcp_service_account_host_file: "{{ service_account_file | default('', true) }}"
gcp_service_account_target_file: "/etc/gitlab/serviceaccount.json"
gcp_project: "{{ project_name | default('', true) }}"
gcp_zone: ""

## AWS
aws_region: ""
aws_allocation_ids: ""

## Alicloud
alicloud_region: ""
alicloud_endpoint: ""

## Tencentcloud
tencentcloud_region: ""
tencentcloud_endpoint: ""

################################################################################
## Network Settings
################################################################################

external_url_sanitised: "{{ external_url | regex_replace('\\/$', '') }}"
external_hostname: "{{ external_url | regex_replace('^https?:\/\/') }}"
external_ip: ""  # IP is only used for Cloud Native Hybrid deployments - provided by user

## External SSL
external_url_ssl: "{{ 'https' in external_url }}"
external_ssl_source: ""  # letsencrypt or user

### Let's Encrypt Certificates
external_ssl_letsencrypt_issuer_email: ""

### User Provided Certificates
external_ssl_files_host_path: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/certificates"
external_ssl_files_host_certificate_file: "{{ external_ssl_files_host_path }}/{{ external_hostname }}.pem"
external_ssl_files_host_key_file: "{{ external_ssl_files_host_path }}/{{ external_hostname }}.key"

## HAProxy
### haproxy_internal_primary_site_group_name: Sets the group name for haproxy_internal_int_ip for Geo or non Geo deployments
haproxy_internal_primary_site_group_name: "{% if 'geo_primary_site_haproxy_internal_primary' in groups %}geo_primary_site_haproxy_internal_primary{% elif 'haproxy_internal' in groups %}haproxy_internal{% else %}{% endif %}"
haproxy_internal_int_ip: "{{ (groups[haproxy_internal_primary_site_group_name] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'haproxy_internal' in groups else ''}}"
haproxy_external_int_ip: "{{ (groups['haproxy_external'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'haproxy_external' in groups else '' }}"
haproxy_external_ext_ip: "{{ (groups['haproxy_external'] | sort | map('extract', hostvars, external_ip_lookup[cloud_provider]) | join('')) if 'haproxy_external' in groups else '' }}"

################################################################################
## GitLab Install Settings
################################################################################

omnibus_node: true

gitlab_version: ""
gitlab_edition: "gitlab-ee"

## Set to env var, package with version wildcard or just latest
gitlab_repo_package: "{{ lookup('env','GITLAB_REPO_PACKAGE') | default(gitlab_edition + '=' + gitlab_version + '*' if gitlab_version != '' else 'gitlab-ee', true) }}"
gitlab_repo_script_url: "{{ lookup('env','GITLAB_REPO_SCRIPT_URL') | default('https://packages.gitlab.com/install/repositories/gitlab/gitlab-ee/script.deb.sh', true) }}"
gitlab_repo_script_path: "/tmp/gitlab_install_repository.sh"

gitlab_deb_force_install: false
## Specify absolute path to the local deb package on host
gitlab_deb_host_path: "{{ lookup('env','GITLAB_HOST_DEB_PATH')}}"
## Specify deb package url
gitlab_deb_download_url: "{{ lookup('env','GITLAB_DEB_DOWNLOAD_URL')}}"
gitlab_deb_download_url_headers: "{{ lookup('env','GITLAB_DEB_DOWNLOAD_URL_HEADERS') | default('', true) }}"
gitlab_deb_target_path: "{{ lookup('env','GITLAB_TARGET_DEB_PATH') | default('/tmp/gitlab_deb_package.deb', true)}}"

gitlab_admin_email: "admin@example.com"

# Object Storage Buckets
## Will be switched to separate buckets by default in future release
gitlab_object_storage_artifacts_bucket: "{{ prefix }}-artifacts"
gitlab_object_storage_backups_bucket: "{{ prefix }}-backups"
gitlab_object_storage_dependency_proxy_bucket: "{{ prefix }}-dependency-proxy"
gitlab_object_storage_external_diffs_bucket: "{{ prefix }}-mr-diffs"
gitlab_object_storage_lfs_bucket: "{{ prefix }}-lfs"
gitlab_object_storage_packages_bucket: "{{ prefix }}-packages"
gitlab_object_storage_terraform_state_bucket: "{{ prefix }}-terraform-state"
gitlab_object_storage_uploads_bucket: "{{ prefix }}-uploads"
gitlab_object_storage_registry_bucket: "{{ prefix }}-registry"

################################################################################
## GitLab Component Settings (Omnibus)
################################################################################

# Consul
consul_int_ips: "{{ (groups['consul'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'consul' in groups else [] }}"

# GitLab Rails (Application nodes)
gitlab_rails_int_ips: "{{ (groups['gitlab_rails'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'gitlab_rails_primary' in groups else [] }}"

# GitLab Postgres / PGBouncer
postgres_primary_int_ip: "{{ (groups['postgres_primary'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'postgres_primary' in groups else '' }}"
postgres_int_ips: "{{ (groups['postgres'] | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'postgres' in groups else [] }}"
pgbouncer_int_ips: "{{ (groups['pgbouncer'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'pgbouncer' in groups else [] }}"

postgres_host: "{{ postgres_primary_int_ip }}"
postgres_port: "5432"
postgres_username: "gitlab"
postgres_password: ""
postgres_database_name: "gitlabhq_production"
postgres_external: "{{ 'postgres' not in groups and postgres_host != '' }}"

## Postgres Omnibus
postgres_replication_manager: "{{ 'patroni' if ((groups['postgres'] is defined) and (groups['postgres'] | length > 1)) else 'none' }}"

# Gitaly
gitaly_primary_int_ip: "{{ (groups['gitaly_primary'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'gitaly_primary' in groups else '' }}"
gitaly_secondary_int_ips: "{{ (groups['gitaly_secondary'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'gitaly_secondary' in groups else [] }}"
gitaly_callback_internal_api_url: "{{ ('http://' + haproxy_internal_int_ip) if 'haproxy_internal' in groups and 'gitlab_rails' in groups else external_url_sanitised }}"

# Praefect
praefect_primary_int_ip: "{{ (groups['praefect_primary'] | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'praefect_primary' in groups else '' }}"
praefect_secondary_int_ips: "{{ (groups['praefect_secondary'] | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'praefect_secondary' in groups else [] }}"
praefect_int_ips: "{{ (groups['praefect'] | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'praefect' in groups else [] }}"

## Praefect Postgres
praefect_postgres_int_ip: "{{ (groups['praefect_postgres'] | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'praefect_postgres_primary' in groups else '' }}"
praefect_postgres_username: "praefect"
praefect_postgres_password: ""
praefect_postgres_database_name: "praefect_production"

# GitLab Monitor
monitor_int_ip: "{{ (groups['monitor'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'monitor' in groups else '' }}"
monitor_custom_dashboards: []
monitor_custom_dashboards_path: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/grafana"

# GitLab Redis
## General
redis_password: ""

## Combined
redis_primary_int_ip: "{{ (groups['redis_primary'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'redis' in groups else '' }}"
redis_int_ips: "{{ (groups['redis'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'redis' in groups else [] }}"

redis_host: "{{ redis_primary_int_ip }}"
redis_port: 6379
redis_external: "{{ 'redis' not in groups and redis_host != '' }}"

## Cache
redis_cache_primary_int_ip: "{{ (groups['redis_cache_primary'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'redis_cache' in groups else '' }}"
redis_cache_int_ips: "{{ (groups['redis_cache'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'redis_cache' in groups else [] }}"

redis_cache_host: "{{ redis_cache_primary_int_ip }}"
redis_cache_port: "{{ redis_port }}"
redis_cache_external: "{{ 'redis_cache' not in groups and redis_cache_host != '' }}"

## Persistent
redis_persistent_primary_int_ip: "{{ (groups['redis_persistent_primary'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'redis_persistent' in groups else '' }}"
redis_persistent_int_ips: "{{ (groups['redis_persistent'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'redis_persistent' in groups else [] }}"

redis_persistent_host: "{{ redis_persistent_primary_int_ip }}"
redis_persistent_port: "{{ redis_port }}"
redis_persistent_external: "{{ 'redis_persistent' not in groups and redis_persistent_host != '' }}"

redis_sentinel_port: 26379
redis_external_ssl: true

# Sidekiq
sidekiq_max_concurrency: 10

################################################################################
## GitLab Component Settings (Non-Omnibus)
################################################################################

# GitLab NFS
gitlab_nfs_int_ip: "{{ groups['gitlab_nfs'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('') }}"
gitlab_nfs_path: "/mnt/gitlab-nfs"

# Elastic
elasticsearch_clean_install: "{{ lookup('env','ELASTICSEARCH_CLEAN_INSTALL') | default('false', true) }}"
elastic_primary_int_ip: "{{ (groups['elastic_primary'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'elastic_primary' in groups else '' }}"
elastic_int_ips: "{{ (groups['elastic'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | list) if 'elastic' in groups else [] }}"
elasticsearch_urls: "{{ (elastic_int_ips | map('regex_replace', '^(.*)$', 'http://\\1:9200') | list) if elastic_int_ips | length > 0 else [] }}"
elasticsearch_replicas: "{{ 1 if (groups['elastic'] | length > 1 ) else 0 }}"
elasticsearch_shards: "{{ (((groups['elastic'] | sort | map('extract', hostvars, ['ansible_processor_vcpus']) | list | sum) / (elasticsearch_replicas | int + 1)) | round | int) if 'elastic' in groups else 0 }}"

# Jaeger Distributed Tracing
jaeger_int_ip: "{{ (groups['jaeger'] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) if 'jaeger' in groups else '' }}"

################################################################################
## GitLab Cloud Native Hybrid Settings (Helm)
################################################################################

cloud_native_hybrid_environment: false
cloud_native_hybrid_geo: false
cloud_native_hybrid_geo_role: ""
kubeconfig_setup: false

gitlab_charts_release_namespace: default
gcp_backups_object_storage_key: "{{ lookup('file', gcp_service_account_host_file) | tojson }}"
aws_backups_object_storage_key: "{{ lookup('template', 'templates/backup_object_storage_key.aws.s3cfg.j2') }}"

gitlab_charts_show_values: false

## Webservice
gitlab_charts_webservice_requests_memory_gb: 5
gitlab_charts_webservice_limits_memory_gb: 5.25
gitlab_charts_webservice_requests_cpu: 4
gitlab_charts_webservice_min_replicas_scaler: 0.75
gitlab_charts_webservice_max_replicas: ""
gitlab_charts_webservice_min_replicas: ""

## Sidekiq
gitlab_charts_sidekiq_requests_memory_gb: 2
gitlab_charts_sidekiq_limits_memory_gb: 4
gitlab_charts_sidekiq_requests_cpu: 0.9
gitlab_charts_sidekiq_min_replicas_scaler: 0.75
gitlab_charts_sidekiq_max_replicas: ""
gitlab_charts_sidekiq_min_replicas: ""

################################################################################
## GitLab Post Configure Settings
################################################################################

access_token_user: "root"
access_token_key: "{{ lookup('password', 'tmp/access-token chars=ascii_lowercase,digits length=20') }}"
access_token_scopes: "[:api]"

################################################################################
## GitLab Component Custom Settings
################################################################################

consul_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/consul.rb"
postgres_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/postgres.rb"
pgbouncer_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/pgbouncer.rb"
redis_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/redis.rb"
redis_cache_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/redis_cache.rb"
redis_persistent_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/redis_persistent.rb"
praefect_postgres_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/praefect_postgres.rb"
praefect_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/praefect.rb"
gitaly_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/gitaly.rb"
gitlab_rails_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/gitlab_rails.rb"
sidekiq_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/sidekiq.rb"
monitor_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/monitor.rb"

gitlab_charts_custom_config_file: "{{ inventory_dir | default(ansible_inventory_sources[0], true) }}/../files/gitlab_configs/gitlab_charts.yml"

################################################################################
## GitLab Geo Settings
################################################################################

geo_primary_site_name: "Primary Site"
geo_secondary_site_name: "Secondary Site"

geo_replication_slot_modifier: "{{ 2 if 'geo_primary_site' in group_names else 1 }}"
geo_primary_site_postgres_group_name: "{% if 'geo_primary_site_postgres_primary' in groups %}geo_primary_site_postgres_primary{% elif 'geo_primary_site_gitlab_rails_primary' in groups %}geo_primary_site_gitlab_rails_primary{% elif 'postgres_primary' in groups%}postgres_primary{% else %}gitlab_rails_primary{% endif %}"
geo_primary_site_postgres_int_ip: "{{ (groups[geo_primary_site_postgres_group_name] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) }}"
geo_secondary_site_postgres_group_name: "{% if 'geo_secondary_site_postgres_primary' in groups %}geo_secondary_site_postgres_primary{% elif 'geo_secondary_site_gitlab_rails_primary' in groups %}geo_secondary_site_gitlab_rails_primary{% else %}gitlab_rails_primary{% endif %}"
geo_secondary_site_postgres_int_ip: "{{ (groups[geo_secondary_site_postgres_group_name] | sort | map('extract', hostvars, internal_ip_lookup[cloud_provider]) | join('')) }}"
